import unittest
import io
import contextlib
from unittest.mock import patch

from tmc import points

from tmc.utils import load, get_stdout
main = load('src.main', 'main')


@points('2.3')
class MainTest(unittest.TestCase):

    def test_00_something_is_printed(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        if not printed:
            self.fail('Et tulostanut mitään!')

    def test_01_prints_all_to_different_lines(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        lines = printed.split('\n')
        self.assertTrue(len(lines)>1,msg='Et tulostanut kaikkia tuloksia omalle rivilleen.')

    def test_02_prints_first_complex_numb(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[0].strip()
        import numpy as np
        self.assertEqual(line, str(complex(0,1)**2), msg='Et tulostanut ensimmäistä kompleksilukua oikein')

    def test_03_prints_second_complex_numb(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[1].strip()
        import numpy as np
        self.assertEqual(line, str(complex(1,1)), msg='Et tulostanut toista kompleksilukua oikein')

    def test_04_prints_third_complex_numb(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[2].strip()
        import numpy as np
        self.assertEqual(line, str(complex(2,3)), msg='Et tulostanut kolmatta kompleksilukua oikein')

    def test_05_prints_sum_complex_numb(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[3].strip()
        import numpy as np
        a = complex(1,1) + complex(2,3)
        self.assertEqual(line, str(a), msg='Et tulostanut kompleksilukujen summaa oikein')

    def test_06_prints_real_part(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[4].strip()
        import numpy as np
        a = np.real(complex(1,1) + complex(2,3))
        self.assertEqual(line, str(a), msg='Et tulostanut kompleksilukuvun reaaliosaa oikein')

    def test_07_prints_imaginary_part(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[5].strip()
        import numpy as np
        a = np.imag(complex(1,1) + complex(2,3))
        self.assertEqual(line, str(a), msg='Et tulostanut kompleksilukuvun imaginääriosaa oikein')

    def test_08_prints_angle(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[6].strip()
        import numpy as np
        a = np.angle(complex(1,1) + complex(2,3))
        self.assertEqual(line, str(a), msg='Et tulostanut kompleksilukujen välistä kulmaa oikein')

    def test_09_prints_conjugate(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[7].strip()
        import numpy as np
        a = np.conj(complex(1,1) + complex(2,3))
        self.assertEqual(line, str(a), msg='Et tulostanut kompleksilukujen konjugaattia oikein')
